#!/usr/bin/perl
use utf8; # yes were using utf8 for everytihng
use CGI qw(:cgi);
use CGI::Carp qw(fatalsToBrowser);
BEGIN {
  # Stacktrace anzeigen. Auch fr warnings
  $SIG{__DIE__} = sub { CGI::Carp::confess @_ };
  $SIG{__WARN__} = sub { CGI::Carp::confess @_; exit; };
}
use Time::HiRes qw (gettimeofday tv_interval); 
use Archive::Zip qw( :ERROR_CODES :CONSTANTS );
my $timeStarted=gettimeofday; # note our start time in msecs# $start = Time.now()
our $cgi = new CGI;
my $timeUpload;
my $timeUnzip;
my $timeThumbnails;
our $UPLOAD_DIR = "./tmp";
our $HTML_TEMPLATE = qq{
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>File Upload (Perl)</title>
</head><body><h1>File Upload (Perl)</h1>
<form action="" method="post" enctype="multipart/form-data">
<input type="hidden" name="action" value="upload"/>
File name: <input name="file" type="file"/><br/>
<input name="submit" type="submit"/>
</form>
</body>
</html>
};

my $UPLOAD_TEMPLATE = qq{
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>Gallery View (Perl)</title>
</head><body><h1>Gallery View (Perl)</h1>
};

sub errorPage {
	my ($text) = @_;
	print $cgi->header();
 	print qq{<html><body><h1>$text</h1></body></html>};
 	exit()
}
     
sub processFile {
	my ($form_field) = @_;  
	$fileitem = $cgi->param($form_field);
	$filepath = $UPLOAD_DIR."/".$fileitem;
	open DAT,">$filepath" or die 'Error processing file: ',$!;
	# Dateien in den Binaer-Modus schalten
	binmode $filepath;
	binmode DAT;
	my $data;
	while(read $fileitem,$data,1024) {
	  print DAT $data;
	}
	close DAT;
	return $filepath;
}

sub unzip {
	my ($file, $path) = @_;  
  $zip = Archive::Zip->new();
  $zip->read($file);
  my @members = $zip->members();
  foreach (@members) {
    my $file=$_->fileName(); 
    if ($file=~m/.*\/(.*)$/) {
      $file = $1; 
    }
    if ($file) {
      $zip->extractMemberWithoutPaths($_,$path."/".$file);
    }
  }
}

sub createThumbnails {
	my ($path) = @_;
	opendir(DIR, $path) or die "Can't open $dir: $!";
	my @allfiles = readdir(DIR);
	closedir(DIR);
	foreach $file (@allfiles) {
		if ($file =~ m/^\./) {
			unlink($path."/".$file);
			next;
		}
		next if ($file =~ m/^\./ || !($file =~ m/\.jpg$/) || $file =~ m/_T\.jpg$/);
		$inputfile = $path."/".$file;
 		$file =~ /(.*)\.jpg$/;
		$outputfile = $path."/".$1."_T.jpg";
		$cmd = "/usr/local/bin/convert -resize 100x100 $inputfile $outputfile";
		system($cmd) || unlink($file);
	}
}

sub generateWebsite {
	my ($path) = @_;
 	my $html = $UPLOAD_TEMPLATE;
	opendir(DIR, $path) or die "Can't open $dir: $!";
	my @allfiles = readdir(DIR);
	closedir(DIR);
	foreach $file (@allfiles) {
		next if ($file =~ m/^\./ || !($file =~ m/\.jpg$/) || $file =~ m/_T\.jpg$/);
		$inputfile = $path."/".$file;
 		$file =~ /(.*)\.jpg$/;
		$outputfile = $path."/".$1."_T.jpg";
 		$html .= qq{<div class="image">};
 		$html .= qq{<a href="$inputfile"><img src="$outputfile"/></a>};
 		$html .= qq{</div>};
 	}
 	$html .= "Store file: $timeUpload seconds<br/>";
 	$html .= "Unzip file: ".($timeUnzip-$timeUpload)." seconds<br/>";
	$html .= "Create thumbnails: ".($timeThumbnails-$timeUnzip)." seconds<br/>";
 	$html .= "Overall: $timeThumbnails seconds<br/>";
 	$html .= "</body></html>";
	return $html;
}

if ($#ARGV >= 1) {
	# wir haben ein command line argument!
	print "Command line\n";
	my $filepath = $ARGV[0];
	$timeUpload = gettimeofday-$timeStarted;
	unzip($filepath, $UPLOAD_DIR);
	$timeUnzip = gettimeofday-$timeStarted;
	createThumbnails($UPLOAD_DIR);
	$timeThumbnails = gettimeofday-$timeStarted;
	my $html = generateWebsite($UPLOAD_DIR);
	open (MYFILE, '>gallery.html');
	print MYFILE $html;
	close MYFILE;
	exit()
} else {
	if (defined $cgi->param('action') && $cgi->param('action') eq "upload") {
		my $filepath = processFile('file');
		$timeUpload = gettimeofday-$timeStarted;
		unzip($filepath, $UPLOAD_DIR);
		$timeUnzip = gettimeofday-$timeStarted;
		createThumbnails($UPLOAD_DIR);
		$timeThumbnails = gettimeofday-$timeStarted;
		print $cgi->header();
		print generateWebsite($UPLOAD_DIR);
		exit()
	}
		
	print $cgi->header();
	print $HTML_TEMPLATE;
}



